/* OSLib---efficient, type-safe, transparent, extensible,
 * register-safe API coverage of RISC OS
 * 
 * Copyright (c) 1994-2012 Jonathan Coxhead and OSLib maintainers
 * 
 * Licence:
 * 
 *    OSLib is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 1, or (at your option)
 * any later version - and this with the following clarification and
 * special exception:
 * 
 *    Linking this library statically or dynamically with other modules
 * is making a combined work based on this library. Thus, the terms
 * and conditions of the GNU General Public License cover the whole
 * combination.
 * 
 *    As a special exception, the copyright holders of this library
 * give you permission to link this library with independent modules
 * to produce an executable, regardless of the license terms of these
 * independent modules, and to copy and distribute the resulting
 * executable under terms of your choice, provided that you also meet,
 * for each linked independent module, the terms and conditions of the
 * license of that module. An independent module is a module which is
 * not derived from or based on this library. If you modify this
 * library, you may extend this exception to your version of the library,
 * but you are not obliged to do so. If you do not wish to do so, delete
 * this exception statement from your version.
 * 
 *    OSLib is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 *    You should have received a copy of the GNU General Public License
 * along with this programme; if not, write to the Free Software
 * Foundation, Inc, 675 Mass Ave, Cambridge, MA 02139, USA.
 */

using OSLib;
using OSLib.Toolbox;
using OSLib.Gadget;
using OSLib.Font;

[CCode (cheader_filename = "oslib/displayfield.h")]
namespace OSLib.DisplayField
{
  [CCode (cname = "displayfield_gadget")]
  public struct Gadget
  {
    [CCode (cname = "text")]
    public unowned Toolbox.MsgReference Text;
    [CCode (cname = "text_limit")]
    public unowned int TextLimit;
  }

  [CCode (cname = "displayfield_object")]
  public struct Object : OSLib.Gadget.ObjectBase
  {
    [CCode (cname = "text")]
    public unowned Toolbox.MsgReference Text;
    [CCode (cname = "text_limit")]
    public unowned int TextLimit;
  }

  [CCode (cname="class_DISPLAY_FIELD")]
  public const Toolbox.Class Class_DisplayField;
  [CCode (cname="displayfield_RJUSTIFIED")]
  public const OSLib.Gadget.Flags RJustified;
  [CCode (cname="displayfield_HCENTRED")]
  public const OSLib.Gadget.Flags HCentred;

  [CCode (cname = "xdisplayfield_set_value")]
  public static OS.Error* XSetValue
    (bits flags,
     Toolbox.O window,
     Toolbox.C display_field,
     string text);

  [CCode (cname = "displayfield_set_value")]
  public static void SetValue
    (bits flags,
     Toolbox.O window,
     Toolbox.C display_field,
     string text);

  [CCode (cname = "xdisplayfield_get_value")]
  public static OS.Error* XGetValue
    (bits flags,
     Toolbox.O window,
     Toolbox.C display_field,
     char* buffer,
     int size,
     out int used);

  [CCode (cname = "displayfield_get_value")]
  public static int GetValue
    (bits flags,
     Toolbox.O window,
     Toolbox.C display_field,
     char* buffer,
     int size);

  [CCode (cname = "xdisplayfield_set_font")]
  public static OS.Error* XSetFont
    (bits flags,
     Toolbox.O window,
     Toolbox.C display_field,
     string font,
     int width,
     int height);

  [CCode (cname = "displayfield_set_font")]
  public static void SetFont
    (bits flags,
     Toolbox.O window,
     Toolbox.C display_field,
     string font,
     int width,
     int height);

}
