/* OSLib---efficient, type-safe, transparent, extensible,
 * register-safe API coverage of RISC OS
 * 
 * Copyright (c) 1994-2012 Jonathan Coxhead and OSLib maintainers
 * 
 * Licence:
 * 
 *    OSLib is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 1, or (at your option)
 * any later version - and this with the following clarification and
 * special exception:
 * 
 *    Linking this library statically or dynamically with other modules
 * is making a combined work based on this library. Thus, the terms
 * and conditions of the GNU General Public License cover the whole
 * combination.
 * 
 *    As a special exception, the copyright holders of this library
 * give you permission to link this library with independent modules
 * to produce an executable, regardless of the license terms of these
 * independent modules, and to copy and distribute the resulting
 * executable under terms of your choice, provided that you also meet,
 * for each linked independent module, the terms and conditions of the
 * license of that module. An independent module is a module which is
 * not derived from or based on this library. If you modify this
 * library, you may extend this exception to your version of the library,
 * but you are not obliged to do so. If you do not wish to do so, delete
 * this exception statement from your version.
 * 
 *    OSLib is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 *    You should have received a copy of the GNU General Public License
 * along with this programme; if not, write to the Free Software
 * Foundation, Inc, 675 Mass Ave, Cambridge, MA 02139, USA.
 */

using OSLib;
using OSLib.OS;
using OSLib.OSSpriteOp;

[CCode (cheader_filename = "oslib/dragasprite.h")]
namespace OSLib.DragASprite
{
  [CCode (cname = "dragasprite_flags")]
  public enum Flags
  {
    [CCode (cname = "dragasprite_HPOS_LEFT")]
    HPosLeft,
    [CCode (cname = "dragasprite_HPOS_CENTRE")]
    HPosCentre,
    [CCode (cname = "dragasprite_HPOS_RIGHT")]
    HPosRight,
    [CCode (cname = "dragasprite_VPOS_BOTTOM")]
    VPosBottom,
    [CCode (cname = "dragasprite_VPOS_CENTRE")]
    VPosCentre,
    [CCode (cname = "dragasprite_VPOS_TOP")]
    VPosTop,
    [CCode (cname = "dragasprite_NO_BOUND")]
    NoBound,
    [CCode (cname = "dragasprite_BOUND_TO_WINDOW")]
    BoundToWindow,
    [CCode (cname = "dragasprite_GIVEN_BBOX")]
    GivenBBox,
    [CCode (cname = "dragasprite_BOUND_SPRITE")]
    BoundSprite,
    [CCode (cname = "dragasprite_BOUND_POINTER")]
    BoundPointer,
    [CCode (cname = "dragasprite_DROP_SHADOW")]
    DropShadow,
    [CCode (cname = "dragasprite_NO_DITHER")]
    NoDither,
    [CCode (cname = "dragasprite_CENTER_ON_PTR_POS")]
    CenterOnPtrPos
  }

  [CCode (cname="dragasprite_SYSTEM_SPRITE_AREA")]
  public static OSSpriteOp.Area* SystemSpriteArea;
  [CCode (cname="dragasprite_WIMP_SPRITE_AREA")]
  public static OSSpriteOp.Area* WimpSpriteArea;

  [CCode (cname = "xdragasprite_start")]
  public static OS.Error* XStart
    (Flags flags,
     OSSpriteOp.Area area,
     string sprite_name,
     OS.Box box,
     OS.Box bbox);

  [CCode (cname = "dragasprite_start")]
  public static void Start
    (Flags flags,
     OSSpriteOp.Area area,
     string sprite_name,
     OS.Box box,
     OS.Box bbox);

  [CCode (cname = "xdragasprite_stop")]
  public static OS.Error* XStop ();

  [CCode (cname = "dragasprite_stop")]
  public static void Stop ();

}
