/* OSLib---efficient, type-safe, transparent, extensible,
 * register-safe API coverage of RISC OS
 * 
 * Copyright (c) 1994-2012 Jonathan Coxhead and OSLib maintainers
 * 
 * Licence:
 * 
 *    OSLib is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 1, or (at your option)
 * any later version - and this with the following clarification and
 * special exception:
 * 
 *    Linking this library statically or dynamically with other modules
 * is making a combined work based on this library. Thus, the terms
 * and conditions of the GNU General Public License cover the whole
 * combination.
 * 
 *    As a special exception, the copyright holders of this library
 * give you permission to link this library with independent modules
 * to produce an executable, regardless of the license terms of these
 * independent modules, and to copy and distribute the resulting
 * executable under terms of your choice, provided that you also meet,
 * for each linked independent module, the terms and conditions of the
 * license of that module. An independent module is a module which is
 * not derived from or based on this library. If you modify this
 * library, you may extend this exception to your version of the library,
 * but you are not obliged to do so. If you do not wish to do so, delete
 * this exception statement from your version.
 * 
 *    OSLib is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 *    You should have received a copy of the GNU General Public License
 * along with this programme; if not, write to the Free Software
 * Foundation, Inc, 675 Mass Ave, Cambridge, MA 02139, USA.
 */

using OSLib;
using OSLib.OS;
using OSLib.Wimp;
using OSLib.Toolbox;
using OSLib.Window;
using OSLib.Gadget;

[CCode (cheader_filename = "oslib/windowsupportexternal.h")]
namespace OSLib.WindowSupportExternal
{
  [CCode (cname="windowsupportexternal_HANDLER_ADD")]
  public const int HandlerAdd;
  [CCode (cname="windowsupportexternal_HANDLER_REMOVE")]
  public const int HandlerRemove;
  [CCode (cname="windowsupportexternal_HANDLER_FADE")]
  public const int HandlerFade;
  [CCode (cname="windowsupportexternal_HANDLER_METHOD")]
  public const int HandlerMethod;
  [CCode (cname="windowsupportexternal_HANDLER_CLICK")]
  public const int HandlerClick;
  [CCode (cname="windowsupportexternal_HANDLER_PLOT")]
  public const int HandlerPlot;
  [CCode (cname="windowsupportexternal_HANDLER_SET_FOCUS")]
  public const int HandlerSetFocus;
  [CCode (cname="windowsupportexternal_HANDLER_MOVE")]
  public const int HandlerMove;
  [CCode (cname="windowsupportexternal_HANDLER_POST_ADD")]
  public const int HandlerPostAdd;

  [CCode (cname = "xwindowsupportexternal_create_icon")]
  public static OS.Error* XCreateIcon
    (bits flags,
     Wimp.IconCreate icon,
     out Wimp.I i);

  [CCode (cname = "windowsupportexternal_create_icon")]
  public static Wimp.I CreateIcon
    (bits flags,
     Wimp.IconCreate icon);

  [CCode (cname = "xwindowsupportexternal_create_object")]
  public static OS.Error* XCreateObject
    (Toolbox.CreateFlags flags,
     Toolbox.Id id,
     out Toolbox.O obj);

  [CCode (cname = "windowsupportexternal_create_object")]
  public static Toolbox.O CreateObject
    (Toolbox.CreateFlags flags,
     Toolbox.Id id);

  [CCode (cname = "xwindowsupportexternal_create_gadget")]
  public static OS.Error* XCreateGadget
    (bits flags,
     Toolbox.O obj,
     OSLib.Gadget.Object gadget,
     int tag,
     out Toolbox.C cmp);

  [CCode (cname = "windowsupportexternal_create_gadget")]
  public static Toolbox.C CreateGadget
    (bits flags,
     Toolbox.O obj,
     OSLib.Gadget.Object gadget,
     int tag);

  [CCode (cname = "xwindowsupportexternal_alloc")]
  public static OS.Error* XAlloc
    (bits flags,
     int size,
     out char* data);

  [CCode (cname = "windowsupportexternal_alloc")]
  public static char* Alloc
    (bits flags,
     int size);

  [CCode (cname = "xwindowsupportexternal_free")]
  public static OS.Error* XFree
    (bits flags,
     char* data);

  [CCode (cname = "windowsupportexternal_free")]
  public static void Free
    (bits flags,
     char* data);

  [CCode (cname = "xwindowsupportexternal_realloc")]
  public static OS.Error* XRealloc
    (bits flags,
     char* data,
     int size_increase,
     out char* data_out);

  [CCode (cname = "windowsupportexternal_realloc")]
  public static char* Realloc
    (bits flags,
     char* data,
     int size_increase);

}
